#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1 White

//---- input parameters
//---- buffers
extern int a_ichi=22;
int ts,ks,sb;

double    

mode_ts,
mode_ks,
mode_sb,
mode_sa,
mode_cs,
trend,
markt;

double way[];
//----
int a_begin;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----
   SetIndexStyle (0,DRAW_HISTOGRAM,STYLE_SOLID,2);
   SetIndexBuffer(0,way);
   //SetIndexShift(0,1);   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Ichimoku Kinko Hyo                                               |
//+------------------------------------------------------------------+
int start()
  {
        ts=a_ichi*0.5;
        ks=a_ichi*1.5;
        sb=a_ichi*3.0;
         
        int counted_bars=IndicatorCounted();
         if(counted_bars>0) counted_bars--;
         int limit=Bars-counted_bars;
         for(int i=0; i<limit; i++)
         {
         mode_ts = iIchimoku(NULL,0,ts,ks,sb,MODE_TENKANSEN,i);
         mode_ks = iIchimoku(NULL,0,ts,ks,sb,MODE_KIJUNSEN,i);
         mode_sb = iIchimoku(NULL,0,ts,ks,sb,MODE_SENKOUSPANB,i-ks);
         mode_sa = iIchimoku(NULL,0,ts,ks,sb,MODE_SENKOUSPANA,i-ks);
         mode_cs = iIchimoku(NULL,0,ts,ks,sb,MODE_CHINKOUSPAN,i+ks);
         
         markt=(mode_cs-mode_sa);
         trend=(mode_ts-mode_ks);         
         
         way[i]=-(trend-markt)/Point;
         }
         IndicatorDigits(0);
   return(0);
  }
//+------------------------------------------------------------------+